"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  renderString: function() {
    return _utils.renderString;
  },
  EjsAPI: function() {
    return EjsAPI;
  }
});
const _define_property = require("@swc/helpers/_/_define_property");
const _codesmith = require("@modern-js/codesmith");
const _utils = require("./utils");
class EjsAPI {
  async renderTemplate(templateResource, target, parameters = {}) {
    if (templateResource._type !== _codesmith.FS_RESOURCE) {
      throw new Error("resource not match");
    }
    const resourceValue = await templateResource.value();
    if (typeof resourceValue.content !== "string") {
      throw new Error(`resource.value is not string, resourceValue=${resourceValue}`);
    }
    await this.generatorCore.output.fs(target, (0, _utils.renderString)(resourceValue.content, parameters), {
      encoding: "utf-8"
    });
  }
  async renderTemplateDir(material, findGlob, target, options) {
    const resourceMap = await material.find(findGlob, {
      nodir: true,
      ...options
    });
    await Promise.all(
      // resourceKey is relate path. example: in `garr-master/package.json`, package.json is resourceKey
      Object.keys(resourceMap).map(async (resourceKey) => {
        this.generatorCore.logger.debug(`[renderDir] resourceKey=${resourceKey}`);
        await this.renderTemplate(material.get(resourceKey), target(resourceKey), options === null || options === void 0 ? void 0 : options.parameters);
      })
    );
  }
  constructor(generatorCore) {
    _define_property._(this, "generatorCore", void 0);
    this.generatorCore = generatorCore;
  }
}
